/**Classe reprsentant une carte:
 * - un nom
 * - une image
 * - un type
 * @author Caldoche
 */

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.util.Vector;

import javax.swing.*;

public class Carte{

	private String nom;
	private String complementaire=""; // Exemple: la complmentaire d'une crevaison est une roue de secours.
	public JLabel image;
	public ImageIcon icon;
	public boolean botte=false;
	public boolean grosseBorne=false;
	public boolean petiteBorne=false;
	public boolean attaque=false;
	public boolean parade=false;
	public boolean accident=false;
	public boolean reparation=false;
	public boolean panne=false;
	public boolean essence=false;
	public boolean crevaison=false;
	public boolean roueDeSecours=false;
	public boolean limit = false;
	public boolean finLimit=false;
	public boolean feuV=false;
	public boolean feuR=false;

	////////////////////////////////////////////////////////
	//						Constructeur				  //
	////////////////////////////////////////////////////////
	
	public Carte(String nom, String path){
		// Une carte  un nom et une reprsentation.
		// Les booleens de type de carte sont fixs par
		// le constructeur du paquet de carte.
		this.nom=nom;
		this.icon = new ImageIcon(path);
		this.image = new JLabel(this.icon);
	}
	
	////////////////////////////////////////////////////////
	//						Accesseurs					  //
	////////////////////////////////////////////////////////
	/**Accesseur
	 * @return String
	 */
	public String getNom(){
		return this.nom;
	}
	/**Accesseur
	 * @return String
	 */
	public String getComplementaire(){
		return this.complementaire;
	}
	/**Accesseur
	 * @param s String
	 * 
	 */
	public void setComplementaire(String s){
		this.complementaire = s;
	}
	
	////////////////////////////////////////////////////////
	//						Methodes					  //
	////////////////////////////////////////////////////////
	
	/** Affiche la carte dans le container en paramtre
	 * @param c Container
	 */
	public void afficherCarteDans(Container c){
		c.setLayout(new FlowLayout());
		c.removeAll();
		c.add(image);
	}
	/**
	 * Retourne un vecteur compos des joueurs attaquables par la carte sauf le joueur plac en paramtre
	 * @param sauf Joueur
	 * @return Vector<Joueur>
	 */
	public Vector<Joueur> joueursAttaquables(Joueur sauf){
		// Cette methode est trs pratique pour mieux grer la methode
		// cible qui dfinit sur quelle deck on peut jouer la carte.
		Vector<Joueur> joueursAttaquables = new Vector<Joueur>();
		for (int i=0;i<Jeu.partie.joueurs.size();i++){
			if (Jeu.partie.joueurs.elementAt(i).cartePossible(this)
					&&(this.attaque||this.feuR||this.limit)
					&& Jeu.partie.joueurs.elementAt(i)!=sauf){
				// Le moteur du jeu regarde qui peut potentiellement tre
				// la cible d'une carte de type attaque.
				joueursAttaquables.add(Jeu.partie.joueurs.elementAt(i));
			}
		}
		return joueursAttaquables;
	}

}
