/** Methode qui cre un JPanel du deck d'un joueur. Elle dispose aussi des spcificits de ce deck
 * @author Caldoche
 */
import javax.swing.*;
import javax.swing.border.Border;

import java.util.*;
import java.awt.*;

public class Deck extends JPanel{

	// Variables d'instance "classiques" d'un deck
	private Carte carteBlanche = new Carte("blanche","");
	private Joueur j;
	private Vector<Carte> cartesDuDeck = new Vector<Carte>();
	public Carte carteVisibleFeux=carteBlanche;
	public Carte carteVisibleLimitations=carteBlanche;
	public int km=0;
	private int nbDeBottes=0;
	private int nb200=0;
	
	// Ensemble des JPanels d'un deck
	private JPanel bottes = new JPanel();
	private JPanel botte1 = new JPanel();
	private JPanel botte2 = new JPanel();
	private JPanel botte3 = new JPanel();
	private JPanel botte4 = new JPanel();
	private JPanel intermediaire=new JPanel();
	private JPanel go = new JPanel();
	private JPanel feux = new JPanel();
	private JPanel limitations = new JPanel();
	private JPanel vitesses = new JPanel();
	private JPanel v25 = new JPanel();
	private JPanel v50 = new JPanel();
	private JPanel v75 = new JPanel();
	private JPanel v100 = new JPanel();
	private JPanel v200 = new JPanel();
	
	private int tailleEnX;
	private int tailleEnY;
	
	private Border reliefHaut = BorderFactory.createRaisedBevelBorder();
	private Border reliefBas = BorderFactory.createLoweredBevelBorder();
	
	////////////////////////////////////////////////////////
	//						Constructeur				  //
	////////////////////////////////////////////////////////
	
	public Deck(Joueur j){
		
		this.j = j;
		this.tailleEnX = this.getSize().width;
		this.tailleEnY = this.getSize().height;
		j.setDeck(this);		
		
		//Reglage des bordures:
		this.setBorder(BorderFactory.createTitledBorder(this.reliefHaut,this.j.getNom()));
		this.bottes.setBorder(BorderFactory.createTitledBorder("Les bottes"));
		this.go.setBorder(BorderFactory.createTitledBorder("Les feux"));
		this.vitesses.setBorder(BorderFactory.createTitledBorder("Les kilometres : "+this.km+" km actuellement"));
		this.v25.setBorder(this.reliefBas);
		this.v50.setBorder(this.reliefBas);
		this.v75.setBorder(this.reliefBas);
		this.v100.setBorder(this.reliefBas);
		this.v200.setBorder(this.reliefBas);
		this.feux.setBorder(this.reliefBas);
		this.limitations.setBorder(this.reliefBas);
		this.botte1.setBorder(this.reliefBas);
		this.botte2.setBorder(this.reliefBas);
		this.botte3.setBorder(this.reliefBas);
		this.botte4.setBorder(this.reliefBas);
		
		//Reglage des Layouts:
		this.setLayout(new BoxLayout(this,BoxLayout.LINE_AXIS));
		this.intermediaire.setLayout(new BoxLayout(this.intermediaire,BoxLayout.PAGE_AXIS));
		this.vitesses.setLayout(new BoxLayout(this.vitesses,BoxLayout.LINE_AXIS));
		this.go.setLayout(new BoxLayout(this.go,BoxLayout.PAGE_AXIS));
		this.bottes.setLayout(new BoxLayout(this.bottes,BoxLayout.LINE_AXIS));
		
		//Reglage des tailles:
		this.go.setMinimumSize(new Dimension(this.tailleEnX/4,this.tailleEnY));		
	
		
		//Ajouts:
		this.add(this.intermediaire);
		this.add(this.go);
		this.intermediaire.add(this.bottes);
		this.intermediaire.add(this.vitesses);
		this.bottes.add(this.botte1);
		this.bottes.add(this.botte2);
		this.bottes.add(this.botte3);
		this.bottes.add(this.botte4);
		this.vitesses.add(this.v25);
		this.vitesses.add(this.v50);
		this.vitesses.add(this.v75);
		this.vitesses.add(this.v100);
		this.vitesses.add(this.v200);
		this.go.add(this.feux);
		this.go.add(this.limitations);
	}

	////////////////////////////////////////////////////////
	//						Accesseur					  //
	////////////////////////////////////////////////////////

	public Vector<Carte> getCartesDuDeck(){
		return this.cartesDuDeck;
	}
	
	////////////////////////////////////////////////////////
	//						Methodes					  //
	////////////////////////////////////////////////////////
	
	/** Ajoute une carte dans le deck
	 * @param c Carte
	 */
	public void ajouterCarte(Carte c){
		// Cette mthode dfinit le placement de la carte qu'on lui ajoute.
		// Elle est assez complique car il faut differentier chaque type de carte...
		this.cartesDuDeck.addElement(c);
		if (c.attaque||c.parade||c.feuR||c.feuV){
			c.afficherCarteDans(this.feux);
			this.carteVisibleFeux=c;
		}
		if (c.limit||c.finLimit){
			c.afficherCarteDans(this.limitations);
			this.carteVisibleLimitations=c;
		}
		if (c.botte){
			// Points
			this.j.score+=200;
			this.nbDeBottes++;
			switch (this.nbDeBottes){
			// En fonction du nombre du bottes que possde le joueur,
			// on les place dans un des 4 JPanel associ.
			case 1: c.afficherCarteDans(this.botte1); break;
			case 2: c.afficherCarteDans(this.botte2); break;
			case 3: c.afficherCarteDans(this.botte3); break;
			default : c.afficherCarteDans(this.botte4); break;
			}
			this.repaint();
			// Une botte annule l'effet d'une attaque en cours,
			// c'est  ce moment l qu'on gre a.
			if(c.getNom().equals("Vhicule Prioritaire") 
					&& !this.carteVisibleFeux.attaque){
				this.carteVisibleFeux=this.carteBlanche;
				this.carteVisibleLimitations=this.carteBlanche;
			}
			if(c.getNom().equals("As du volant") 
					&& this.carteVisibleFeux.accident){
				this.carteVisibleFeux=this.carteBlanche;
			}
			if(c.getNom().equals("Increvable") 
					&& this.carteVisibleFeux.crevaison){
				this.carteVisibleFeux=this.carteBlanche;
			}
			if(c.getNom().equals("Citerne") 
					&& this.carteVisibleFeux.panne){
				this.carteVisibleFeux=this.carteBlanche;
			}
		}
		if (c.petiteBorne || c.grosseBorne){
			if(c.getNom().equals("25")){
				c.afficherCarteDans(this.v25);
				this.km+=25;
			}
			if(c.getNom().equals("50")){
				c.afficherCarteDans(this.v50);
				this.km+=50;
			}
			if(c.getNom().equals("75")){
				c.afficherCarteDans(this.v75);
				this.km+=75;
			}
			if(c.getNom().equals("100")){
				c.afficherCarteDans(this.v100);
				this.km+=100;
			}
			if(c.getNom().equals("200")&& this.nb200<2){
				// On ne peut pas ajouter plus de deux 200
				// Nota: Les 200 jous en trop ne sont donc mme pas dfausss...
				// Voila une mthode  amliorer...
				
				// PS: Heureusement qu'on recre un paquet  chaque partie sinon
				// il manquerait des cartes...
				this.nb200++;
				c.afficherCarteDans(this.v200);
				this.km+=200;
			}
			this.vitesses.setBorder(BorderFactory.createTitledBorder("Les kilometres : "+this.km+" km actuellement"));
			this.repaint();
		}		
	}
	
	/**
	 * Cette methode met le panel du deck en surbrillance
	 */
	public void mettreEnSurbrillance(){
		this.setBorder(BorderFactory.createLineBorder(Color.RED, 3));
	}
	
	/**
	 * Cette methode retire la surbrillance du deck
	 */
	public void retirerLaSurbrillance(){
		this.setBorder(BorderFactory.createTitledBorder(this.reliefHaut,this.j.getNom()));
	}


	// Voici 4 mthodes qui signalent si un joueur possde l'une ou l'autre des
	// bottes du jeu => Ces methodes sont trs utiles pour l'IA et la validit des
	// coups.
	
	/**
	 * Si le joueur possde la botte increvable
	 * @return boolean
	 */
	public boolean increvable(){
		boolean aRetourner = false;
		for (int i = 0; i<this.cartesDuDeck.size();i++){
			if (this.cartesDuDeck.elementAt(i).getNom().equals("Increvable")){
				aRetourner= true;
			}
		}
		return aRetourner;
	}
	
	/**
	 * Si le joueur possde la botte vhicule prioritaire
	 * @return boolean
	 */
	public boolean prioritaire(){
		boolean aRetourner = false;
		for (int i = 0; i<this.cartesDuDeck.size();i++){
			if (this.cartesDuDeck.elementAt(i).getNom().equals("Vhicule prioritaire")){
				aRetourner= true;
			}
		}
		return aRetourner;
	}
	
	/**
	 * Si le joueur possde la botte as du volant
	 * @return boolean
	 */
	public boolean as(){
		boolean aRetourner = false;
		for (int i = 0; i<this.cartesDuDeck.size();i++){
			if (this.cartesDuDeck.elementAt(i).getNom().equals("As du volant")){
				aRetourner= true;
			}
		}
		return aRetourner;
	}
	
	/**
	 * Si le joueur possde la botte camion citerne
	 * @return boolean
	 */
	public boolean citerne(){
		boolean aRetourner = false;
		for (int i = 0; i<this.cartesDuDeck.size();i++){
			if (this.cartesDuDeck.elementAt(i).getNom().equals("Citerne")){
				aRetourner= true;
			}
		}
		return aRetourner;
	}
}
