import java.awt.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.*;
import javax.swing.border.Border;

import java.util.*;


public class FenetreDeJeu extends JFrame {

	Container pane = this.getContentPane();
	JPanel table;
	JPanel mainPioche;
	
	public FenetreDeJeu(){
		this.setTitle("Le jeu du Mille Bornes");
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent arg0) {
			System.exit(0);	
			}
		});
		this.setLayout(new FlowLayout());
		this.insererImageMilleBornes();
		}
	
	/**
	 * Insere l'image du mille bornes en fond
	 */
	private void insererImageMilleBornes(){
		ImageIcon milleBorne = new ImageIcon("icones/MilleBornes.jpg");
		JLabel img = new JLabel(milleBorne);
		this.pane.add(img);
	}
	
	/**
	 * Construit l'ensemble du plateau de jeu (pioche, decks, mains...)
	 * @param joueurs Vector<Joueur>
	 */
	public void construirePlateauDeJeu(Vector<Joueur> joueurs){
		this.pane.removeAll();
		this.construireTable(joueurs);
		this.construireMainEtPioche(joueurs);
		this.pane.setLayout(new BoxLayout(this.pane,BoxLayout.PAGE_AXIS));
		this.pane.add(table);
		this.pane.add(mainPioche);
		this.pack();
		Jeu.mettreEnPleinEcran(this);
		this.setVisible(true);


	}
		
	/**
	 * Construit la table de jeu (les decks)
	 * @param joueurs Vector<Joueur>
	 */
	public void construireTable(Vector<Joueur> joueurs){
		this.table = new JPanel(new GridLayout(2,3));
		Border bord = BorderFactory.createMatteBorder(5,1,5,1,Color.GREEN);
		this.table.setBorder(BorderFactory.createTitledBorder(bord,"Table de jeu"));
		this.table.setPreferredSize(new Dimension(this.getSize().width,3*this.getSize().height/4));
		this.table.setMinimumSize(new Dimension(this.getSize().width,3*this.getSize().height/4));
		this.table.setMaximumSize(new Dimension(this.getSize().width,3*this.getSize().height/4));
		for(int i=0;i<joueurs.size();i++){
			Deck d = new Deck(joueurs.elementAt(i));
			this.table.add(d);
		}
	}
	
	/**
	 * Construit le bas de la fenetre (main et pioche)
	 * @param joueurs Vector<Joueur>
	 */
	public void construireMainEtPioche(Vector<Joueur> joueurs){
		this.mainPioche = new JPanel();
		this.mainPioche.setLayout(new BoxLayout(this.mainPioche,BoxLayout.LINE_AXIS));
		this.mainPioche.setBorder(BorderFactory.createRaisedBevelBorder());
	}
	
	/**
	 * Permet de changer la main affiche
	 * @param j Joueur
	 */
	public void afficherMain(Joueur j){
		this.mainPioche.removeAll();
		this.mainPioche.add(Jeu.partie.joueurEnCours.getMain().afficherMain());
		this.mainPioche.add(Jeu.partie.getPioche());
	}
}
