import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class FenetreParametres extends JFrame {

	private int nbJoueurs=3;
	private JPanel pane = (JPanel)this.getContentPane();
	private JPanel nomsJoueurs = new JPanel(new BorderLayout());
	private Vector<JTextField> champs = new Vector<JTextField>();
	private Vector<JCheckBox> humains = new Vector<JCheckBox>();
	private Vector<Joueur> joueursDeLaPartie = new Vector<Joueur>(3);
	
	public FenetreParametres(){
		this.setTitle("Reglage des paramtres");
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent arg0) {
			((JFrame)arg0.getSource()).dispose();	
			}
		});
		this.setLayout(new BorderLayout());
		this.add(creerSelectionNbJoueurs(),BorderLayout.NORTH);
		this.add(creerSelectionNomsJoueurs(),BorderLayout.CENTER);
		this.add(creerBoutonsValidationAnnuler(),BorderLayout.SOUTH);
		this.setLocation(400,400);
		this.setAlwaysOnTop(true);
		
	}
	private JPanel creerSelectionNbJoueurs(){
		JPanel selecNbJr = new JPanel(new FlowLayout());
		JLabel info = new JLabel("Selectionnez le nombre de joueurs souhait:   ");
		SpinnerNumberModel model = new SpinnerNumberModel(3,2,6,1);
		JSpinner nbJr = new JSpinner(model);
		nbJr.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent arg0) {
				FenetreParametres.this.nbJoueurs=Integer.parseInt(((JSpinner)arg0.getSource()).getValue().toString());
				FenetreParametres.this.pane.add(FenetreParametres.this.creerSelectionNomsJoueurs(),BorderLayout.CENTER);}
		});
		
		selecNbJr.add(info);selecNbJr.add(nbJr);
		return selecNbJr;
	}
	private JPanel creerSelectionNomsJoueurs(){
		this.nomsJoueurs.removeAll();
		this.joueursDeLaPartie.clear();
		JLabel info = new JLabel ("Entrez les noms des differents joueurs:");
		
		for (int i=0; i<6; i++){
			champs.add(new JTextField("Joueur "+(i+1)));
			humains.add(new JCheckBox("Humain?"));
		}
		// On ne met que le nombre ncessaire de JTextField
		JPanel selecNomsJr2 = new JPanel(new GridLayout(2,3));
		this.nomsJoueurs.add(info,BorderLayout.CENTER);
		for (int i=0; i<this.nbJoueurs; i++){
			JPanel duo=new JPanel();
			duo.add(champs.elementAt(i));
			duo.add(humains.elementAt(i));
			selecNomsJr2.add(duo);
		}

		this.nomsJoueurs.add(selecNomsJr2,BorderLayout.SOUTH);
		this.nomsJoueurs.repaint();
		this.pack();
		this.setVisible(true);
		return this.nomsJoueurs;
		
	}
	private JPanel creerBoutonsValidationAnnuler(){
		// C'est dans cette methode qu'on lance la partie
		JPanel boutons = new JPanel(new FlowLayout());
		JButton annuler = new JButton("Annuler");
		annuler.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				Jeu.partie.demarrerPartie();
			}
		});
		JButton accepter = new JButton("Ok");
		accepter.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				FenetreParametres.this.joueursDeLaPartie.clear();
				for (int i=0;i<FenetreParametres.this.nbJoueurs; i++){
					FenetreParametres.this.joueursDeLaPartie.add(new Joueur(FenetreParametres.this.champs.elementAt(i).getText()));
					FenetreParametres.this.joueursDeLaPartie.elementAt(i).humain=(FenetreParametres.this.humains.elementAt(i).isSelected());
				}
				if(FenetreParametres.this.joueursDeLaPartie.size()==FenetreParametres.this.nbJoueurs){
					Jeu.partie.nbJoueurs=FenetreParametres.this.nbJoueurs;
					// La partie commence avec les options selectionnes lorsqu'on cre le plateau de jeu:
					Jeu.partie.creerPlateauDeJeu(joueursDeLaPartie);}
			}
		});
		annuler.setPreferredSize(new Dimension(100,30));accepter.setPreferredSize(new Dimension(100,30));
		boutons.add(accepter);
		JPanel separation = new JPanel(); 
		separation.setPreferredSize(new Dimension(50,30));
		boutons.add(separation);
		boutons.add(annuler);
		return boutons;
	}
	
}
