import java.awt.*;
import java.awt.geom.Dimension2D;
import java.util.*;
import javax.swing.*;
import javax.swing.plaf.basic.DefaultMenuLayout;

// Classe main du jeu du Mille Bornes.
public class Jeu {

	
	public static Partie partie;
	public static FenetreDeJeu fenetrePrincipale;
	public static int tailleEcranX;
	public static int tailleEcranY;
	
	
	public static void main(String[] args){
		// On affiche la fenetre de jeu avec l'image de fond.
		// On la met aussi en plein cran
		fenetrePrincipale = new FenetreDeJeu();
		fenetrePrincipale.pack();
		mettreEnPleinEcran(fenetrePrincipale);
		fenetrePrincipale.setVisible(true);
		// On attend 2 secondes avant de commencer une partie
		try {
			Thread.sleep(2000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		Jeu.partie = new Partie();
		// La partie commence
		Jeu.partie.demarrerPartie();
	}
	
	
	/**
	 * Permet de mettre le jeu en plein cran
	 * @param frame JFrame
	 */
	public static void mettreEnPleinEcran(JFrame frame){
		Toolkit kit = Toolkit.getDefaultToolkit();
		 Insets insets = kit.getScreenInsets(frame.getGraphicsConfiguration());
		 Dimension screen = kit.getScreenSize();
		 //calcul des longueurs ncessaires et de la position
		 int w = (int)(screen.getWidth()-insets.left-insets.right);
		 tailleEcranX=w;
		 int h = (int)(screen.getHeight()-insets.top-insets.bottom);
		 tailleEcranY=h;
		 int x = (int)(insets.left);
		 int y = (int)(insets.top);
		 Dimension dimension = new Dimension(w,h);
		 frame.setSize(dimension);
		 frame.setLocation(x,y);
	}
}
