
import java.awt.Component;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.border.Border;

public class Main {

	private Carte carteBlanche = new Carte("blanche","");
	private Carte[] cartesDeLaMain = new Carte[7];
	private JPanel[] inserts = new JPanel[6];
	public Carte carteAPoser;
	public Vector<Joueur> joueurVise = new Vector<Joueur>();
	private JFrame selectionJoueur;
	
	////////////////////////////////////////////////////////
	//						Constructeur				  //
	////////////////////////////////////////////////////////
	
	public Main(){
		this.cartesDeLaMain[6]=this.carteBlanche;
		for (int i=0;i<6;i++){
			this.inserts[i]= new JPanel();
			this.inserts[i].setBorder(BorderFactory.createLoweredBevelBorder());
		}
		this.creerActionsSurMain();
	}
	
	////////////////////////////////////////////////////////
	//						Accesseur					  //
	////////////////////////////////////////////////////////
	
	public Carte[] getCartesDeLaMain(){
		return this.cartesDeLaMain;
	}
	
	////////////////////////////////////////////////////////
	//						Methodes					  //
	////////////////////////////////////////////////////////
	
	/**
	 * Ajoute une carte dans la main
	 * @param c Carte
	 * @param position int
	 */
	public void ajouterCarte(Carte c, int position){
		this.cartesDeLaMain[position]=c;
	}
	
	/**
	 * retire la carte c de la main
	 * @param c
	 */
	public void retirerCarte(Carte c){
		// Lorsqu'on retire une carte de la main, celle-ci est remplace
		// par la carte venant d'tre pioche (donc a l'indice 6)
		// sauf bien sur si c'est celle qui vient d'tre joue.
		for (int i=0;i<7;i++){
			// cherche la carte en question dans la main du joueur
			if(this.cartesDeLaMain[i]==c){
				this.cartesDeLaMain[i]=this.cartesDeLaMain[6];
				this.cartesDeLaMain[6]=this.carteBlanche;
				if(Jeu.partie.joueurEnCours.humain && i!=6){
					this.cartesDeLaMain[i].afficherCarteDans(this.inserts[i]);
				}
				// L'actualisation de la pioche est ncessaire pour remettre
				// l'image du dos des cartes.
				Jeu.partie.pioche.actualiserPioche();
				Jeu.fenetrePrincipale.pack();
				Jeu.fenetrePrincipale.repaint();
			}
		}
	}
	/**
	 * Cre une fentre de confirmation avant de jouer la carte.
	 * @param c
	 * @param cible
	 */
	public void confirmer(Carte c, Joueur cible){
		if(Jeu.partie.joueurEnCours.humain){
			switch (JOptionPane.showConfirmDialog
					(null,
							"Un(e) "+c.getNom()+" sur "+cible.getNom()+"?",
							"Etes-vous sur?",
							JOptionPane.YES_NO_OPTION,
							JOptionPane.QUESTION_MESSAGE,
							c.icon)) {
			case JOptionPane.YES_OPTION: this.jouerCarte(c, cible);
				break;
			
			default:
				break;
			}
		}else{
			this.jouerCarte(c, cible);
		}
		
	}
	public void confirmerDefausse(Carte c){
		if(Jeu.partie.joueurEnCours.humain){
			switch (JOptionPane.showConfirmDialog
					(null,
							"Voulez-vous vraiment defausser votre "+c.getNom()+"?",
							"Etes-vous sur?",
							JOptionPane.YES_NO_OPTION,
							JOptionPane.QUESTION_MESSAGE,
							c.icon)) {
			case JOptionPane.YES_OPTION: Jeu.partie.pioche.defausser(c);
				break;
			
			default:
				break;
			}
		}else{
			Jeu.partie.pioche.defausser(c);
		}
	}
	
	/**
	 * Joue une carte, elle examine les possibilits de jeu et [propose les / effectue la] seule(s) possible(s)
	 * @param c Carte
	 * @param cible Joueur
	 */
	public void jouerCarte(Carte c, Joueur cible){
		// Il faut bien comprendre que la cible et le joueur possedant la main
		// (c'est  dire le joueur en cours)ne sont pas forcement les memes 
		// (lorsqu'on joue une attaque par exemple)
		
		
		// Ds qu'une carte est joue, on vrifie tout d'abord qu'il ne
		// s'agit pas d'un coup fourr!
		// Les conditions sont assez excplicites
		if((c.accident && cible.mainContient("As du volant"))
				||(c.crevaison && cible.mainContient("Increvable"))
				||(c.panne && cible.mainContient("Citerne"))
				||((c.feuR||c.limit) && cible.mainContient("Vhicule prioritaire"))){
			// On est dans le cas d'un coup fourr, le moteur du jeu extrait
			// la carte joue de la main de joueur en cours.
			this.retirerCarte(c);
			System.out.println("un coup fourr a eu lieu !");
			if (Jeu.partie.joueurEnCours.cartePossible(c)){
				System.out.println("La carte se retourne contre l'attaquant");
				// Lors d'un coup fourr, l'attaque se retourne (si possible)
				// contre le joueur en cours!
				Jeu.partie.joueurEnCours.getDeck().ajouterCarte(c);
			}
			// Le joueur qui a fait le coup fourr prend alors la main
			// C'est la mthode joueUnCoupFoure qui gere le tour de jeu en cas
			// de coup fourr (il faut piocher deux cartes etc etc).
			cible.joueUnCoupFoure(c);
		}else{
			// Si nous ne sommes pas dans le cas d'un coup four:
			// Le moteur du jeu extrait la carte joue de la main du
			// joueur en cours.
			this.retirerCarte(c);
			// La carte est alors pose sur le deck de la cible.
			cible.getDeck().ajouterCarte(c);
			Jeu.fenetrePrincipale.pack();
			Jeu.fenetrePrincipale.repaint();
			// La fin d'un tour est une mthode  part entire.
			Jeu.partie.joueurEnCours.finirTour();	
		}
	}
	
	/**
	 * Recense les joueurs qui pourraient tre la cble de la carte c
	 * @param c Carte
	 */
	public void cible(Carte c){
		// Chaque fois qu'une carte est joue, cette methode est apeller pour
		// que le coup soit forcement valide.
		// Si la carte ne peut-tre joue  personne, elle est defausse.
		this.carteAPoser=c;
		if ((c.botte 
				|| c.parade 
				|| c.petiteBorne 
				|| c.grosseBorne 
				|| c.feuV
				|| c.finLimit)
				// Les cartes de type botte, borne ou parade sont forcement joues
				// sur le deck du joueur en cours (si il le peut).
				&& Jeu.partie.joueurEnCours.cartePossible(c)){
			//this.joueurVise.add();
			// La methode jouerCarte de la classe Main s'occupe du transfert de la carte.
			
			this.confirmer(c, Jeu.partie.joueurEnCours);
			//this.jouerCarte(c, Jeu.partie.joueurEnCours);
		}else{
			// Si la carte est de type attaque,
			// ou si le joueur en cours ne peut pas s'ajouter de carte de type
			// parade ou botte:
			this.joueurVise = c.joueursAttaquables(Jeu.partie.joueurEnCours);
			Vector<String> nomsEtKm = new Vector<String>();
			for (int i=0; i<this.joueurVise.size();i++){
				nomsEtKm.add(this.joueurVise.elementAt(i).getNom()
						+ " avec "+ this.joueurVise.elementAt(i).getDeck().km+" km");
			}
			if(this.joueurVise.size()==0){
				// Si l'ensemble des joueurs qui peuvent tre la cible de la carte,
				// c'est la carte n'est pas jouable. Elle est donc defausse et 
				// cela termine le tour de jeu
				
				
				this.confirmerDefausse(c);
				//Jeu.partie.pioche.defausser(c);
			}else{
				// Si il n'y a qu'un seul joueur qui peut-tre attaqu, le moteur
				// du jeu comprend que c'est sur ce joueur que doit tre joue la
				// carte.
				if(this.joueurVise.size()==1){
					
					
					this.confirmer(c, this.joueurVise.elementAt(0));
					//this.jouerCarte(c, this.joueurVise.elementAt(0));
				}else{
					// Si il y en a plusieurs, Il y a une nouvelle fentre qui s'ouvre permettant de
					// choisir le joueur qu'on veut attaquer. Le nombre de km de chaque joueur est
					// spcifi pour faciliter le choix.

					// Cette fentre est trs simple. Un menu droulant s'ouvre
					// et on selectionne le joueur que l'on souhaite attaquer.
					this.selectionJoueur = new JFrame("Quel joueur souhaitez vous attaquer?");
					this.selectionJoueur.setLocation(400,600);
					Container pane = this.selectionJoueur.getContentPane();
					JComboBox joueurs = new JComboBox(nomsEtKm);
					joueurs.addActionListener(new ActionListener(){
						public void actionPerformed(ActionEvent arg0) {
							int joueur = ((JComboBox)arg0.getSource()).getSelectedIndex();
							
							
							confirmer(Main.this.carteAPoser, Main.this.joueurVise.elementAt(joueur));
							//jouerCarte(Main.this.carteAPoser,Main.this.joueurVise.elementAt(joueur));
							// On cache ensuite la fentre de selection.
							selectionJoueur.setVisible(false);
						}	
					});
					
					pane.add(joueurs);
					selectionJoueur.setAlwaysOnTop(true);
					selectionJoueur.pack();
					selectionJoueur.setVisible(true);
				}
			}
		}
	}

	// Voici les deux seules mthodes d'IHM de la classe Main.
	
	/**
	 * Retourne le JPanel reprsentant la main du joueur.
	 * @return JPanel
	 */
	public JPanel afficherMain(){
		// Cette methode est apelle  chaque tour de jeu d'un joueur humain.
		// C'est elle qui permet de voir les cartes de notre main.
		JPanel main = new JPanel();
		main.setLayout(new BoxLayout(main,BoxLayout.LINE_AXIS));
		Border bord = BorderFactory.createRaisedBevelBorder();
		main.setBorder(BorderFactory.createTitledBorder(bord,"Votre main"));
		for (int i = 0;i<6;i++){
			this.inserts[i].setBorder(BorderFactory.createLoweredBevelBorder());
			this.cartesDeLaMain[i].afficherCarteDans(this.inserts[i]);
			main.add(this.inserts[i]);
		}
		return main;
		
	}

	/**
	 * Permet au joueur humain de pouvoir cliquer sur une carte pour la jouer
	 */
	private void creerActionsSurMain(){
		
		for (int i=0;i<6;i++){
			this.inserts[i].addMouseListener(new MouseListener(){
				public void mouseClicked(MouseEvent arg0) {
				}
				public void mouseEntered(MouseEvent arg0) {	
				}
				public void mouseExited(MouseEvent arg0) {	
				}
				public void mousePressed(MouseEvent arg0) {	
				}
				public void mouseReleased(MouseEvent arg0) {
					for (int i=0;i<6;i++){
						if((JPanel)arg0.getSource()==inserts[i]
						                                     &&Jeu.partie.joueurEnCours!=null
						                                     &&Jeu.partie.joueurEnCours.humain
						                                     // Cette condition spcifie que 
						                                     // l'humain ne peut pas jouer de
						                                     // carte de sa main si ce n'est pas
						                                     // son tour
						                                     ){
							// La mthode cible va permettre le choix
							// du joueur qui sera la cible de la carte.
							cible(cartesDeLaMain[i]);
						}
					}
				}
			});
			
		}
	}

}
