import java.util.*;

public class PaquetDeCartes extends Vector<Carte> {

	public int facteur=1;
	private int nbCartesDuPaquet;
	private int n25 = 10;
	private int n50 = 10;
	private int n75 = 10;
	private int n100 = 12;
	private int n200 = 4;
	private int nbLimit = 4;
	private int nbFinLimit = 6;
	private int nbVert = 14;
	private int nbRouge = 4;
	private int nbCrev = 3;
	private int nbRoueSec = 6;
	private int nbPanne = 3;
	private int nbEss = 6;
	private int nbAcc=  3;
	private int nbRepar=  6;
	private String path = "Kart-Mi-le-Bord-noeud";
	
	////////////////////////////////////////////////////////
	//						Constructeur				  //
	////////////////////////////////////////////////////////
	
	public PaquetDeCartes(){
		this(1);
	}
	
	public PaquetDeCartes(int n){
		// Ce constructeur cre n fois les cartes ncessaires mais
		// ne met que 4 bottes en tout, quelque soit le nombre de jeux
		// utiliss.
		this.facteur=n;
		for (int i=0;i<this.n25*facteur;i++){
			Carte c = new Carte("25",this.path+"/vin-seins-queue.jpg");
			c.petiteBorne=true;
			this.add(c);
			
		}
		for (int i=0;i<this.n50*facteur;i++){
			Carte c= new Carte("50",this.path+"/seins-quand-te.jpg");
			c.petiteBorne=true;
			this.add(c);
		}
		for (int i=0;i<this.n75*facteur;i++){
			Carte c=new Carte("75",this.path+"/soie-sans-te-quin-zoeufs.jpg");
			c.grosseBorne=true;
			this.add(c);
		}
		for (int i=0;i<this.n100*facteur;i++){
			Carte c = new Carte("100",this.path+"/sans.jpg");
			c.grosseBorne=true;
			this.add(c);
		}
		for (int i=0;i<this.n200*facteur;i++){
			Carte c = new Carte("200",this.path+"/de-sans.jpg");
			c.grosseBorne=true;
			this.add(c);
		}
		for (int i=0;i<this.nbAcc*facteur;i++){
			Carte c= new Carte("Accident",this.path+"/ac-scie-dent.jpg");
			c.attaque=true;
			c.accident=true;
			c.setComplementaire("Rparation");
			this.add(c);
		}
		for (int i=0;i<this.nbCrev*facteur;i++){
			Carte c = new Carte("Crevaison",this.path+"/peu-noeud-creux-V.jpg");
			c.attaque=true;
			c.crevaison=true;
			c.setComplementaire("Roue de secours");
			this.add(c);
		}
		for (int i=0;i<this.nbEss*facteur;i++){
			Carte c = new Carte("Essence",this.path+"/plein-des-sens.jpg");
			c.parade=true;
			c.essence=true;
			c.setComplementaire("Panne d'essence");
			this.add(c);
		}
		for (int i=0;i<this.nbFinLimit*facteur;i++){
			Carte c = new Carte("Fin de limitation",this.path+"/pas-d-oeuf-lit-mie-ta-zion.jpg");
			c.finLimit=true;
			c.setComplementaire("Limitation de vitesse");
			this.add(c);
		}
		for (int i=0;i<this.nbLimit*facteur;i++){
			Carte c =(new Carte("Limitation de vitesse",this.path+"/lit-mie-tas-zion-seins-quand-te.jpg"));
			c.limit=true;
			c.setComplementaire("Fin de limitation");
			this.add(c);
		}
		for (int i=0;i<this.nbPanne*facteur;i++){
			Carte c=(new Carte("Panne d'essence",this.path+"/pas-noeud-des-sens.jpg"));
			c.attaque=true;
			c.panne=true;
			c.setComplementaire("Essence");
			this.add(c);
		}
		for (int i=0;i<this.nbRepar*facteur;i++){
			Carte c = (new Carte("Reparation",this.path+"/raie-part-a-zion.jpg"));
			c.parade=true;
			c.reparation=true;
			c.setComplementaire("Accident");
			this.add(c);
		}
		for (int i=0;i<this.nbRoueSec*facteur;i++){
			Carte c=(new Carte("Roue de secours",this.path+"/roue-deux-se-court.jpg"));
			c.parade=true;
			c.roueDeSecours=true;
			c.setComplementaire("Crevaison");
			this.add(c);
		}
		for (int i=0;i<this.nbRouge*facteur;i++){
			Carte c=(new Carte("Feu rouge",this.path+"/oeuf-rouge.jpg"));
			c.feuR=true;
			c.setComplementaire("Feu vert");
			this.add(c);
		}
		for (int i=0;i<this.nbVert*facteur;i++){
			Carte c=(new Carte("Feu vert",this.path+"/oeuf-ver.jpg"));
			c.feuV=true;
			c.setComplementaire("Feu rouge");
			this.add(c);
		}
		Carte c = new Carte("Vhicule prioritaire",this.path+"/pont-pied.jpg");
		c.botte=true;
		c.setComplementaire("Feu rouge");
		this.add(c);
		c = new Carte("As du volant",this.path+"/veau-lent.jpg");
		c.botte=true;
		c.setComplementaire("Accident");
		this.add(c);
		c = new Carte("Increvable",this.path+"/in-creux-va-bleu.jpg");
		c.botte=true;
		c.setComplementaire("Crevaison");
		this.add(c);
		c = new Carte("Citerne",this.path+"/haie-sens.jpg");
		c.botte=true;
		c.setComplementaire("Panne d'essence");
		this.add(c);
		
		this.nbCartesDuPaquet=this.size();
		
	}

	////////////////////////////////////////////////////////
	//						Methodes					  //
	////////////////////////////////////////////////////////
	/**
	 * Mlange le paquet de carte
	 */
	public void melanger(){
		Vector<Carte> paquetMelange = new Vector<Carte>();
		int i = 0;
		while(i!=this.nbCartesDuPaquet){
			int j=(int)(Math.random()*this.size());
			paquetMelange.add(this.elementAt(j));
			this.remove(j);
			i++;
		}
		this.removeAllElements();
		for(int j=0; j<paquetMelange.size();j++){
			this.addElement(paquetMelange.elementAt(j));
		}
	}
	
	/**
	 * Distribue le paquet de cartes aux joueurs passs en paramtre
	 * @param joueurs
	 */
	public void distribuer(Vector<Joueur> joueurs){
		Main[] mainsADistribuer = new Main[joueurs.size()];
		for (int i=0;i<joueurs.size();i++){
			mainsADistribuer[i]=new Main();
		}
		int i=0;
		while(i!=6){
			for (int j=0;j<joueurs.size();j++){
				mainsADistribuer[j].ajouterCarte(this.lastElement(),i);
				this.removeElement(this.lastElement());
			}
			i++;
		}
		for (int j=0;j<joueurs.size();j++){
			joueurs.elementAt(j).setMain(mainsADistribuer[j]);
		}
	}
}
