import javax.swing.*;

import com.sun.org.apache.xerces.internal.impl.xpath.XPath.LocationPath;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.*;


public class Partie{
	public int nbJoueurs;
	public FenetreParametres parametres;
	public JFrame finPartie;
	public ChangementDeJoueur chgmtDeJoueur;
	public Vector<Joueur> joueurs;
	public PaquetDeCartes paquetDeCartes;
	public Pioche pioche;
	public Joueur joueurEnCours;
	
	////////////////////////////////////////////////////////
	//						Constructeur				  //
	////////////////////////////////////////////////////////
	
	public Partie(){
		this.nbJoueurs=3;
		this.parametres=new FenetreParametres();
		this.joueurs = new Vector<Joueur>();
	}
	
	////////////////////////////////////////////////////////
	//						Accesseurs					  //
	////////////////////////////////////////////////////////
	
	public JPanel getPioche(){
		return this.pioche.getPanelDeLaPioche();
	}
	
	////////////////////////////////////////////////////////
	//						Methodes					  //
	////////////////////////////////////////////////////////
	
	/**
	 * Cre une nouvelle instance de la fentre de paramtre o seront dfinis les joueurs par l'utilisateur
	 */
	public void demarrerPartie(){
		this.parametres.dispose();
		// Le dmarrage de la partie cre une nouvelle fenetre de paramtres
		// qui permet de regler le nombre et les noms des joueurs.
		// La fentre de paramtre apellera la mthode creerPlateauDeJeu une fois remplie.
		this.parametres = new FenetreParametres();
		this.parametres.pack();
		this.parametres.setVisible(true);
		
	}
	
	/**
	 * Une fois que les paramtres ont t choisis, cette mthode cre
	 *  le plateau de jeu en fonction des choix de l'utilisateur.
	 *   C'est cette mthode qui lance le premier tour de jeu.
	 * @param j
	 */
	public void creerPlateauDeJeu(Vector<Joueur> j){
		this.joueurs=j;
		// C'est ici qu'on pourrait dfinir d'autres joueurs humains
		// (avec des JCheckBox dans les paramtres par exemple)
		//this.joueurs.elementAt(0).humain=true;
		this.parametres.dispose();
		// On cre un paquet de cartes dont la taille est adapte au nombre
		// de joueurs.
		this.paquetDeCartes=new PaquetDeCartes(j.size()/2);
		this.paquetDeCartes.melanger();
		this.paquetDeCartes.distribuer(this.joueurs);
		this.pioche= new Pioche(this.paquetDeCartes);
		// Une fois le plateau de jeu bien dfini on peut l'afficher dans notre
		// fentre de jeu.
		Jeu.fenetrePrincipale.construirePlateauDeJeu(this.joueurs);
		// La partie commence toujours par le premier joueur cr.
		// Son tour de jeu est apell dans la classe ChangementDeJoueur
		chgmtDeJoueur = new ChangementDeJoueur(this.joueurs.elementAt((int)Math.random()*this.nbJoueurs));
		
	}
	
	/**
	 * Methode qui gre la fin de la partie. Elle calcule les scores,  
	 * et lance leur affichage
	 */
	public void finirPartie(){
		// On cre un tableau rcapitulatif des scores.
		int[] scores = new int[this.joueurs.size()];
		// Le joueur qui gagne la manche est le joueur le plus avanc,
		// malgr le fait qu'il n'a pas forcement plus de points que les autres.
		Joueur quiAGagne = this.quiALePlusDeKm();
		for(int i=0;i<this.joueurs.size();i++){
			this.joueurs.elementAt(i).calculScore();
			scores[i] = this.joueurs.elementAt(i).getScore();
		}
		// On affiche ensuite la fenetre de fin de partie
		this.afficherFinPartie(scores, quiAGagne);
		
		
	}
	/**
	 * Affiche la fenetre de fin de partie pour les utilisateurs
	 * @param scores
	 * @param vainqueur
	 */
	private void afficherFinPartie(int[] scores, Joueur vainqueur){
		this.finPartie = new JFrame("Flicitations  "+vainqueur.getNom());
		Container pane = this.finPartie.getContentPane();
		pane.setLayout(new BoxLayout(pane,BoxLayout.PAGE_AXIS));
		JLabel[] lab = new JLabel[3+scores.length];
		JPanel[] pan = new JPanel[3+scores.length];
		lab[0]=new JLabel("Le vainqueur de cette partie est "+
				vainqueur.getNom());
		lab[1]=new JLabel("avec "+vainqueur.getScore()+" points!");
		lab[2]=new JLabel("Voici le dtail des scores:");
		for(int i=3;i<lab.length;i++){
			lab[i]=new JLabel(this.joueurs.elementAt(i-3).getNom()+" a marqu "+scores[i-3]+" points");
		}
		for(int i=0;i<lab.length;i++){
			pan[i]=new JPanel();
			
			pan[i].add(lab[i]);
			pane.add(pan[i]);
		}
		JButton rejouer=new JButton("Rejouer");
		rejouer.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				Partie.this.finPartie.dispose();
				Jeu.partie=new Partie();
			}
			
		});
		JButton quitter=new JButton("Quitter");
		quitter.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0){
				System.exit(0);
			}
		});
		JPanel boutons = new JPanel(new FlowLayout());
		boutons.add(rejouer,new FlowLayout());
		boutons.add(quitter,new FlowLayout());
		pane.add(boutons);
		this.finPartie.setPreferredSize(new Dimension(300,300));
		this.finPartie.setLocation(300,300);
		this.finPartie.pack();
		this.finPartie.setVisible(true);
	}
	
	public Joueur quiALePlusDeKm(){
		int index=0;
		int kmDuPlusBalaise=this.joueurs.elementAt(0).getDeck().km;
		for(int i=1;i<this.joueurs.size();i++){
			if (this.joueurs.elementAt(i).getDeck().km > kmDuPlusBalaise){
				index = i;
				kmDuPlusBalaise=this.joueurs.elementAt(i).getDeck().km;
			}
		}
		return this.joueurs.elementAt(index);
	}
	
	
	
}
