import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.Border;

public class Pioche extends PaquetDeCartes {
	
	private JPanel panelDeLaPioche = new JPanel();
	private String nbCartesRestantes;
	
	////////////////////////////////////////////////////////
	//						Constructeur				  //
	////////////////////////////////////////////////////////
	
	public Pioche(PaquetDeCartes carteRestantes){
		this.clear();
		for (int i = 0; i<carteRestantes.size(); i++){
			this.add(carteRestantes.elementAt(i));
		}
		this.calculerCartesPiocheRestantes();
		this.creerPanelDeLaPioche();
	}
	
	////////////////////////////////////////////////////////
	//						Accesseur					  //
	////////////////////////////////////////////////////////
	
	public JPanel getPanelDeLaPioche(){
		return this.panelDeLaPioche;
	}
	
	////////////////////////////////////////////////////////
	//						Methodes					  //
	////////////////////////////////////////////////////////
	
	/**
	 * Cre le panel de la pioche et permet ou non au joueur en cours
	 * de cliquer dessus pour jouer une carte
	 */
	public void creerPanelDeLaPioche(){
		Border bord = BorderFactory.createLoweredBevelBorder();
		this.panelDeLaPioche=new JPanel();
		panelDeLaPioche.addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent arg0) {
				if(Jeu.partie.joueurEnCours!=null
						&&Jeu.partie.joueurEnCours.humain){
						Jeu.partie.joueurEnCours.getMain().cible(Jeu.partie.joueurEnCours.getMain().getCartesDeLaMain()[6]);
						//jouerCarte(cartesDeLaMain[i]);
					}
				}
			public void mouseEntered(MouseEvent arg0) {
				// TODO Auto-generated method stub	
			}
			public void mouseExited(MouseEvent arg0) {
				// TODO Auto-generated method stub	
			}
			public void mousePressed(MouseEvent arg0) {
				// TODO Auto-generated method stub		
			}
			public void mouseReleased(MouseEvent arg0) {
				// TODO Auto-generated method stub	
			}
		});
		ImageIcon dosDesCartes = new ImageIcon("Kart-Mi-le-Bord-noeud/dos-des-kart.jpg");
		JLabel img = new JLabel(dosDesCartes);
		this.panelDeLaPioche.add(img);
		this.panelDeLaPioche.setBorder(BorderFactory.createTitledBorder(bord,this.nbCartesRestantes));
	}
	
	/**
	 * Calcule le nombre de cartes restant dans la pioche pour que les joueurs
	 * puissent savoir si la partie se finit bientot...
	 */
	public void calculerCartesPiocheRestantes(){
		this.nbCartesRestantes=""+this.size();
		Border bord = BorderFactory.createLoweredBevelBorder();
		this.panelDeLaPioche.setBorder(BorderFactory.createTitledBorder(bord,this.nbCartesRestantes));
	}
	
	/**
	 * Defausse la carte en paramtre, la retire de la main du joueur et change de joueur.
	 * @param c
	 */
	public void defausser(Carte c){
		// Lorsqu'une carte est joue mais qu'elle ne peut l'tre sur personne,
		// La carte est automatiquement defausse.
		Jeu.partie.joueurEnCours.getMain().retirerCarte(c);
		// On apelle alors la fin du tour comme dans le cas o la carte est joue
		// sur un joueur.
		Jeu.partie.joueurEnCours.finirTour();
		
		// Nota: Le jeu ne permet pas encore de piocher une carte qui vient d'tre
		// defausse. C'est ici qu'on pourrait ajouter cette fonctionalit.
	}
	
	/**
	 * Actualise les informations et l'affichage de la pioche
	 */
	public void actualiserPioche(){
		this.panelDeLaPioche.removeAll();
		Border bord = BorderFactory.createLoweredBevelBorder();
		ImageIcon dosDesCartes = new ImageIcon("Kart-Mi-le-Bord-noeud/dos-des-kart.jpg");
		JLabel img = new JLabel(dosDesCartes);
		this.panelDeLaPioche.add(img);
		this.panelDeLaPioche.setBorder(BorderFactory.createTitledBorder(bord,this.nbCartesRestantes));
		
	}
	
}
